package hr.unizg.srce.d470.obrasci.iterator;

import java.util.Iterator;

public class Element implements Komponenta {

	private final int broj;

	public Element(int broj) {
		this.broj = broj;
	}

	public Element(Element element) {
		this(element.getBroj());
	}

	public int getBroj() {
		return broj;
	}

	@Override
	public String toString() {
		return "Element [broj=" + getBroj() + "]";
	}

	@Override
	public boolean sadrzi(int broj) {
		System.out.println(this);
		return getBroj() == broj;
	}

	@Override
	public Prototip kloniraj() {
		return new Element(this);
	}

	@Override
	public Iterator<Integer> iterator() {
		return new ElementIterator(this);
	}

	private class ElementIterator implements Iterator<Integer> {

		private boolean hasNext;

		private Element element;

		public ElementIterator(Element element) {
			this.element = element;
			hasNext = true;
		}

		@Override
		public boolean hasNext() {
			return hasNext;
		}

		@Override
		public Integer next() {
			hasNext = false;
			return element.getBroj();
		}

	}

}
