package hr.unizg.srce.d470.parametrizacija;

import java.util.function.BinaryOperator;
import java.util.function.Function;

public class FunkcijskaSucelja {

	private static <T> T obradi(Integer[] brojevi, Function<Integer, T> funkcija, BinaryOperator<T> agregator) {
		T rezultat = null;
		for (int i = 0; i < brojevi.length; ++i) {
			if (i > 0)
				rezultat = agregator.apply(rezultat, funkcija.apply(brojevi[i]));
			else
				rezultat = funkcija.apply(brojevi[i]);
		}
		return rezultat;
	}

	public static void main(String[] args) {
		Integer[] brojevi = new Integer[args.length];
		for (int i = 0; i < args.length; ++i)
			brojevi[i] = Integer.parseInt(args[i]);

		System.out.println("Zbroj: " + obradi(brojevi, x -> x, (x, y) -> x + y));
		System.out.println("Maksimum: " + obradi(brojevi, x -> x, (x, y) -> Math.max(x, y)));
		System.out.println("Minimum: " + obradi(brojevi, x -> x, (x, y) -> Math.min(x, y)));
		System.out.println("Broj neparnih brojeva: " + obradi(brojevi, x -> x % 2, (x, y) -> x + y));
		System.out.println("Zbroj (String): " + obradi(brojevi, x -> x.toString(), (x, y) -> x + y));
		System.out.println("Svi brojevi jednoznamenkasti: " + obradi(brojevi, x -> x / 10 == 0, (x, y) -> x && y));
	}

}
