package hr.unizg.srce.d470.parametrizacija;

public class SadrzajKutije {

	private static class Kutija<T> {
		private T sadrzaj;

		public Kutija() {
			this(null);
		}

		public Kutija(T sadrzaj) {
			this.sadrzaj = sadrzaj;
		}

		public T getSadrzaj() {
			return sadrzaj;
		}

		public void setSadrzaj(T sadrzaj) {
			this.sadrzaj = sadrzaj;
		}
	}

	public static void main(String[] args) {
		Kutija<Integer> cijeliBroj = new Kutija<>();
		cijeliBroj.setSadrzaj(3);
		Kutija<Double> decimalniBroj = new Kutija<>(Math.PI);
		// GRESKA: cijeliBroj = decimalniBroj;

		Kutija<? extends Number> kutija = new Kutija<>();
		kutija = cijeliBroj;
		kutija = decimalniBroj;
		// GRESKA: kutija.setSadrzaj(3.0);
		Number n = kutija.getSadrzaj();
		System.out.println("Kutija sadrzi: " + n);

		Kutija<? super Integer> kutija2 = new Kutija<>();
		kutija2 = cijeliBroj;
		// GRESKA: kutija2 = decimalniBroj;
		kutija2.setSadrzaj(3);
		Object o = kutija2.getSadrzaj();
		System.out.println("Kutija2 sadrzi: " + o);
	}

}
