package hr.unizg.srce.d470.vjezbe.connectx;

public class Igra {

	private Ploca<Zeton> ploca;

	private final Igrac[] igraci;

	private final int brZetonaZaredom;

	public Igra(final int brRedaka, final int brStupaca, final int brZetonaZaredom, final Igrac prviIgrac,
			final Igrac drugiIgrac) {
		this.brZetonaZaredom = brZetonaZaredom;
		igraci = new Igrac[] { prviIgrac, drugiIgrac };
		ploca = new Ploca<>(brRedaka, brStupaca);
	}

	public Ploca<Zeton> getPloca() {
		return ploca;
	}

	public Igrac[] getIgraci() {
		return igraci;
	}

	public int getBrZetonaZaredom() {
		return brZetonaZaredom;
	}

	public StanjeIgre odigraj() {
		int indeksIgraca = 0;

		StanjeIgre stanje;

		for (stanje = StanjeIgre.AKTIVNA; stanje == StanjeIgre.AKTIVNA; stanje = stanjeIgre()) {
			System.out.println(ploca);

			// Strategije.pametnaStrategija(5).apply(this, igraci[indeksIgraca]);

			boolean odigranPotez = false;
			while (!odigranPotez) {
				try {
					Potez potez = igraci[indeksIgraca].odluci(this);
					potez.igraj(ploca);
					odigranPotez = true;
					System.out.println("Igrac " + igraci[indeksIgraca] + " odigrao je potez: " + potez);
				} catch (IllegalArgumentException | PopunjenStupacException ex) {
					System.err.println(ex.getMessage());
				}
			}

			indeksIgraca = (indeksIgraca + 1) % 2;
		}

		System.out.println(ploca);

		return stanje;
	}

	public StanjeIgre stanjeIgre() {
		StanjeIgre stanje = StanjeIgre.AKTIVNA;

		// gore, dolje, desno, lijevo, gorelijevo, doljedesno, goredesno, doljelijevo
		int[] dx = { -1, 1, 0, 0, -1, 1, -1, 1 };
		int[] dy = { 0, 0, 1, -1, -1, 1, 1, -1 };

		for (int i = 0; i < getPloca().getBrRedaka(); ++i) {
			for (int j = 0; j < getPloca().getBrStupaca(); ++j) {
				if (getPloca().getElement(i, j) == null)
					continue;

				for (int k = 0; k < dx.length; ++k) {
					int br = 1;
					for (int di = i + dx[k], dj = j + dy[k]; di >= 0 && di < getPloca().getBrRedaka() && dj >= 0
							&& dj < getPloca().getBrStupaca(); di += dx[k], dj += dy[k], ++br)
						if (getPloca().getElement(i, j) != getPloca().getElement(di, dj))
							break;

					if (br >= brZetonaZaredom) {
						if (getPloca().getElement(i, j) == getIgraci()[0].getZeton()) {
							if (stanje == StanjeIgre.POBJEDA_DRUGI)
								return StanjeIgre.REMI;
							else
								stanje = StanjeIgre.POBJEDA_PRVI;
						} else {
							if (stanje == StanjeIgre.POBJEDA_PRVI)
								return StanjeIgre.REMI;
							else
								stanje = StanjeIgre.POBJEDA_DRUGI;
						}
					}
				}
			}
		}

		return stanje;
	}

	public Igra kopiraj() {
		Igra novaIgra = new Igra(getPloca().getBrRedaka(), getPloca().getBrStupaca(), getBrZetonaZaredom(),
				getIgraci()[0], getIgraci()[1]);
		novaIgra.ploca = getPloca().kopiraj();
		return novaIgra;
	}
}
