package hr.unizg.srce.d470.vjezbe.connectx;

import java.util.InputMismatchException;
import java.util.Scanner;

public class LjudskiIgrac extends Igrac {

	private final Scanner citacUlaznogToka;

	public LjudskiIgrac(final String ime, final Zeton zeton, final Scanner citacUlaznogToka) {
		super(ime, zeton);
		this.citacUlaznogToka = citacUlaznogToka;
	}

	@Override
	public Potez odluci(final Igra igra) {
		final String vrstaPoteza = citacUlaznogToka.next();
		int indeksStupca;

		try {
			indeksStupca = citacUlaznogToka.nextInt();
		} catch (InputMismatchException imex) {
			throw new IllegalArgumentException("Ucitani indeks stupca nije broj.");
		}

		if (indeksStupca < 0 || indeksStupca >= igra.getPloca().getBrStupaca())
			throw new IllegalArgumentException(
					"Ucitani indeks stupca nije u rasponu [0, " + igra.getPloca().getBrStupaca() + "].");

		switch (vrstaPoteza) {
		case "ubaci":
			return new PotezUbaci(indeksStupca, getZeton());
		case "izbaci":
			if (igra.getPloca().getElement(0, indeksStupca) != getZeton())
				throw new IllegalArgumentException("Nije moguce izbaciti zeton iz trazenog stupca.");
			return new PotezIzbaci(indeksStupca);
		default:
			throw new IllegalArgumentException("Nevaljana vrsta poteza.");
		}
	}

}
