package hr.unizg.srce.d470.vjezbe.iznimke;

public class Ploca {

	private final int brRedaka;

	private final int brStupaca;

	private final Zeton[][] ploca;

	public Ploca(final int brRedaka, final int brStupaca) {
		this.brRedaka = brRedaka;
		this.brStupaca = brStupaca;

		ploca = new Zeton[brRedaka][brStupaca];
	}

	public int getBrRedaka() {
		return brRedaka;
	}

	public int getBrStupaca() {
		return brStupaca;
	}

	public int getVisinaStupca(final int stupac) {
		int i;
		for (i = 0; i < brRedaka; ++i)
			if (ploca[i][stupac] == null)
				break;
		return i;
	}

	public Zeton getZeton(final int redak, final int stupac) {
		return ploca[redak][stupac];
	}

	public void ubaciZeton(final int stupac, final Zeton zeton) {
		int visinaStupca = getVisinaStupca(stupac);

		if (visinaStupca >= getBrRedaka())
			throw new PopunjenStupacException("Stupac " + stupac + " je popunjen.");

		ploca[visinaStupca][stupac] = zeton;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (int i = getBrRedaka() - 1; i >= 0; --i) {
			for (int j = 0; j < getBrStupaca(); ++j) {
				Zeton zeton = getZeton(i, j);
				sb.append((zeton == null) ? "." : zeton);
			}
			sb.append("\n");
		}

		return sb.toString();
	}

}
