package hr.unizg.srce.d470.vjezbe.kolekcije;

import java.util.InputMismatchException;
import java.util.Scanner;

public class LjudskiIgrac extends Igrac {

	private final Scanner citacUlaznogToka;

	public LjudskiIgrac(final String ime, final Zeton zeton, final Scanner citacUlaznogToka) {
		super(ime, zeton);
		this.citacUlaznogToka = citacUlaznogToka;
	}

	@Override
	public Potez odluci() {
		final String vrstaPoteza = citacUlaznogToka.next();
		int indeksStupca;

		try {
			indeksStupca = citacUlaznogToka.nextInt();
		} catch (InputMismatchException imex) {
			throw new IllegalArgumentException("Ucitani indeks stupca nije broj.");
		}

		if (indeksStupca < 0)
			throw new IllegalArgumentException("Ucitani indeks stupca (" + indeksStupca + ") nije pozitivan broj.");

		switch (vrstaPoteza) {
		case "ubaci":
			return new PotezUbaci(indeksStupca, getZeton());
		default:
			throw new IllegalArgumentException("Nevaljana vrsta poteza.");
		}
	}

}
