package hr.unizg.srce.d470.vjezbe.kolekcije;

import java.util.EmptyStackException;
import java.util.Stack;

public class Postfiks {

	private static Stack<Double> stog = new Stack<>();

	public static void main(String[] args) {
		try {
			for (String arg : args) {
				double x, y;
				switch (arg) {
				case "+":
					x = stog.pop();
					y = stog.pop();
					stog.push(y + x);
					break;
				case "-":
					x = stog.pop();
					y = stog.pop();
					stog.push(y - x);
					break;
				case "x":
					x = stog.pop();
					y = stog.pop();
					stog.push(y * x);
					break;
				case "/":
					x = stog.pop();
					y = stog.pop();
					stog.push(y / x);
					break;
				default:
					try {
						stog.push(Double.parseDouble(arg));
					} catch (NumberFormatException nfe) {
						throw new IllegalArgumentException(arg);
					}
					break;
				}
			}
		} catch (IllegalArgumentException iae) {
			System.err.format("Nepoznati argument: \"%s\"", iae.getMessage());
			return;
		} catch (EmptyStackException ese) {
			System.err.println("Nevaljani matematicki izraz.");
			return;
		}

		if (stog.size() != 1) {
			System.err.println("Nevaljani matematicki izraz.");
		} else {
			System.out.println("Rezultat je: " + stog.pop());
		}
	}

}
