package hr.unizg.srce.d470.vjezbe.nasljedivanje;

public class Ploca {

	private final int brRedaka;

	private final int brStupaca;

	private final Zeton[][] ploca;

	public Ploca(final int brRedaka, final int brStupaca) {
		this.brRedaka = brRedaka;
		this.brStupaca = brStupaca;

		ploca = new Zeton[brRedaka][brStupaca];
	}

	public int getBrRedaka() {
		return brRedaka;
	}

	public int getBrStupaca() {
		return brStupaca;
	}

	public Zeton getZeton(final int redak, final int stupac) {
		return ploca[redak][stupac];
	}

	public void ubaciZeton(final int stupac, final Zeton zeton) {
		for (int i = 0; i < brRedaka; ++i) {
			if (ploca[i][stupac] == null) {
				ploca[i][stupac] = zeton;
				break;
			}
		}
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (int i = getBrRedaka() - 1; i >= 0; --i) {
			for (int j = 0; j < getBrStupaca(); ++j) {
				Zeton zeton = getZeton(i, j);
				sb.append((zeton == null) ? "." : zeton);
			}
			sb.append("\n");
		}

		return sb.toString();
	}

}
