package hr.unizg.srce.d470.vjezbe.obrasci;

public class Igra {

	private Ploca<Zeton> ploca;

	private final Igrac[] igraci;

	private final int brZetonaZaredom;

	public Igra(final int brRedaka, final int brStupaca, final int brZetonaZaredom, final Igrac prviIgrac,
			final Igrac drugiIgrac) {
		this.brZetonaZaredom = brZetonaZaredom;
		igraci = new Igrac[] { prviIgrac, drugiIgrac };
		ploca = new Ploca<>(brRedaka, brStupaca);
	}

	public Ploca<Zeton> getPloca() {
		return ploca;
	}

	public Igrac[] getIgraci() {
		return igraci;
	}

	public int getBrZetonaZaredom() {
		return brZetonaZaredom;
	}

	public StanjeIgre odigraj() {
		int indeksIgraca = 0;

		StanjeIgre stanje;

		for (stanje = StanjeIgre.AKTIVNA; stanje == StanjeIgre.AKTIVNA;) {
			System.out.println(ploca);
			boolean odigranPotez = false;
			while (!odigranPotez) {
				try {
					Potez potez = igraci[indeksIgraca].odluci(this);
					potez.igraj(ploca);
					odigranPotez = true;
					System.out.println("Igrac " + igraci[indeksIgraca] + " odigrao je potez: " + potez);
				} catch (IllegalArgumentException | PopunjenStupacException ex) {
					System.err.println(ex.getMessage());
				}
			}

			indeksIgraca = (indeksIgraca + 1) % 2;
		}

		System.out.println(ploca);

		return stanje;
	}
}
