package hr.unizg.srce.d470.vjezbe.parametrizacija;

public class Ploca<T> {

	private final int brRedaka;

	private final int brStupaca;

	private final Object[][] ploca;

	public Ploca(final int brRedaka, final int brStupaca) {
		this.brRedaka = brRedaka;
		this.brStupaca = brStupaca;

		ploca = new Object[brRedaka][brStupaca];
	}

	public int getBrRedaka() {
		return brRedaka;
	}

	public int getBrStupaca() {
		return brStupaca;
	}

	public int getVisinaStupca(final int stupac) {
		int i;
		for (i = 0; i < brRedaka; ++i)
			if (ploca[i][stupac] == null)
				break;
		return i;
	}

	@SuppressWarnings("unchecked")
	public T getElement(final int redak, final int stupac) {
		return (T) ploca[redak][stupac];
	}

	public void ubaciElement(final int stupac, final T element) {
		int visinaStupca = getVisinaStupca(stupac);

		if (visinaStupca >= getBrRedaka())
			throw new PopunjenStupacException("Stupac " + stupac + " je popunjen.");

		ploca[visinaStupca][stupac] = element;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (int i = getBrRedaka() - 1; i >= 0; --i) {
			for (int j = 0; j < getBrStupaca(); ++j) {
				T element = getElement(i, j);
				sb.append((element == null) ? "." : element);
			}
			sb.append("\n");
		}

		return sb.toString();
	}

}
